#include <stdlib.h>

//================================================================================================
//================================================================================================
//================================================================================================
//================================================================================================
//================================================================================================
//================================================================================================

float AVRIDLE;

typedef struct noidle {
	float jump;
	float last;
	float next;
	float idle;
	struct noidle *precedant;
	struct noidle *suivant;
	void (*funcptr) (void);
} idle;

struct noidle *celuici, *premier, *dernier;

//================================================================================================
//================================================================================================
//================================================================================================
//================================================================================================
//================================================================================================
//================================================================================================
float lastsecond, sumidle;

float NOiD_iDLE_loop(float time)
{
	float wait;
	if ((premier != NULL)&&(dernier != NULL))
	{
		celuici = premier;
		while (celuici != NULL)
		{
			if (celuici->next <= time)
			{
				if (celuici->funcptr != NULL)
				{
					celuici->last = celuici->next;
					celuici->next = time + celuici->jump;
					celuici->idle = 0;
					wait = 0;
					celuici->funcptr();
				}
			} else {
				celuici->idle = celuici->next - time;
				if (celuici->idle <= wait)
				{	wait = celuici->idle;	}
			}
			celuici = celuici->suivant;
		}
	}
	if (AVRIDLE >= (lastsecond+1))
	{
		AVRIDLE = sumidle;
		sumidle = 0;	
	}
	sumidle += wait;
	return wait;
}

//================================================================================================
//================================================================================================
//================================================================================================

idle * NOiD_iDLE_create(float interval,void (*function)(void))
{
	idle * this;
	if ((premier == NULL)&&(dernier == NULL))
	{
		this = malloc(sizeof(idle));
		this->precedant = NULL;
		this->suivant = NULL;
		premier = this;
		dernier = this;
			this->jump = interval;
			this->next = 0;
			this->last = 0;
			this->idle = 0;
			this->funcptr = function;
	} else {
		if (premier == dernier)
		{
			this = malloc(sizeof(idle));
			dernier = this;
			dernier->precedant = premier;
			dernier->suivant = NULL;
			premier->precedant = NULL;
			premier->suivant = dernier;
				this->jump = interval;
				this->next = 0;
				this->last = 0;
				this->idle = 0;
				this->funcptr = function;
		} else {
			if (dernier->suivant == NULL)
			{
				this = malloc(sizeof(idle));
				this->precedant = dernier;
				this->suivant = NULL;
				dernier->suivant = this;
				dernier = this;
					this->jump = interval;
					this->next = 0;
					this->last = 0;
					this->idle = 0;
					this->funcptr = function;
			}
		}
	}
	return this;
}

//================================================================================================
//================================================================================================
//================================================================================================

void NOiD_iDLE_destroy(idle *this)
{
	if (this != NULL)
	{
		if (premier == dernier)
		{
			premier = NULL;
			dernier = NULL;
			free(this);
		} else {
			if (this->precedant == NULL)
			{
				this->precedant->suivant = NULL;
				premier = this->suivant;
				free(this);
			} else {
				if (this->suivant == NULL)
				{
					this->precedant->suivant = NULL;
					dernier = this->precedant;
					free(this);
				} else {
					this->precedant->suivant = this->suivant;
					this->suivant->precedant = this->precedant;
					free(this);
				}
			}
		}
	}
}

//================================================================================================
//================================================================================================
//================================================================================================
